﻿@page "{handler?}/{emailSid?}"
@model BeamAndGo.Member.Web.Pages.EmailManagementModel
@{
    ViewData["Title"] = "Email Management";
    if (Model.IsXHR) Layout = null;
    else Layout = "_Layout";
}
<div class="uk-margin-small">
    <h3>Email Management</h3>
    @await foreach (var memberEmail in Model.MemberEmails)
    {
        <div class="uk-margin-small @(memberEmail.IsDefault ? "uk-text-bold" : "")">
            <div class="uk-card uk-card-default uk-card-small uk-card-body uk-width-1-1">
                <div uk-grid>
                    <div class="uk-width-expand@s uk-margin-small-top">
                        <p class="uk-form-label"> @memberEmail.Email</p>
                    </div>
                    <div class="uk-width-auto@s uk-margin-remove">
                        <div class="uk-margin-remove uk-text-left@s uk-text-right@m">
                            @if (memberEmail.IsDefault)
                            {
                                <span class="uk-badge uk-label uk-label-success">Primary</span>
                            }
                            @if (memberEmail.IsVerified)
                            {
                                <span class="uk-badge uk-label uk-label-success">Verified</span>
                            }
                            else
                            {
                                <span class="uk-badge uk-label uk-label-warning">Unverified</span>
                            }
                        </div>
                        <div class="uk-margin-medium-top uk-align-right uk-flex-inline">

                            @if (!memberEmail.IsVerified)
                            {
                                <form asp-page-handler="resendverification"
                                      method="post"
                                      asp-antiforgery="true"
                                      asp-route-emailSid="@memberEmail.Sid"
                                      data-ajax="true"
                                      data-ajax-method="post"
                                      data-ajax-success="resendVerificationSuccess"
                                      data-ajax-failure="resendVerificationFailed">
                                    <button class="member-email-resend-verification uk-button uk-button-small"
                                            style="padding:5px 10px;"
                                            type="submit">
                                        <i class="fas fa-check uk-margin-small-right"></i>Verify
                                    </button>
                                </form>
                            }
                            else
                            {
                                if (!memberEmail.IsDefault)
                                {
                                    <form asp-page-handler="makeprimary"
                                          method="post"
                                          asp-antiforgery="true"
                                          asp-route-emailSid="@memberEmail.Sid"
                                          data-ajax="true"
                                          data-ajax-method="post"
                                          data-ajax-success="changePrimarySuccess"
                                          data-ajax-failure="changePrimaryFailed">
                                        <button class="member-email-make-primary uk-button uk-button-small uk-text-nowrap"
                                                style="padding:5px 10px;"
                                                SelectedEmailSid="@memberEmail.Sid"
                                                type="submit">
                                            <i class="fas fa-star uk-margin-small-right"></i>Make Primary
                                        </button>
                                    </form>
                                }
                            }

                            @if (!memberEmail.IsDefault)
                            {
                                <div class="uk-margin-small-left">
                                    <button class="member-email-remove uk-button uk-button-small"
                                            style="padding:5px 10px;"
                                            uk-toggle="target: #modal-email-remove"
                                            SelectedEmailSid="@memberEmail.Sid"
                                            memberEmail="@memberEmail.Email">
                                        <i class="fas fa-trash"></i>
                                    </button>
                                </div>
                            }
                        </div>
                    </div>
                </div>
            </div>
        </div>
    }
    <form asp-page-handler="add" method="post" asp-antiforgery="true" autocomplete="on" data-ajax="true" data-ajax-method="post" data-ajax-success="addEmailSuccess" data-ajax-failure="addEmailFailed">
        <div class="uk-child-width-expand uk-grid-small uk-margin-small-bottom" uk-grid>
            <div class="uk-width-expand">
                <input asp-for="@Model.NewEmail" class="uk-input" type="email" placeholder="E-mail address">
                <span asp-validation-for="@Model.NewEmail" id="new-email-error" class="uk-text-danger uk-text-small"></span>
            </div>
            <div class="uk-width-auto">
                <button class="uk-button uk-button-primary uk-align-right uk-margin-remove-bottom" style="padding:0px 10px; margin-left:0px" type="submit"><i class="fas fa-plus"></i></button>
            </div>

        </div>
    </form>
</div>

<!-- This is the modal -->
<div id="modal-email-verification" uk-modal>
    <div class="uk-modal-dialog uk-margin-auto-vertical">
        <div class="uk-modal-body uk-text-center">
            <p>A verification e-mail has been sent to <i><span class="modal-email-for-verified"></span></i>. Please follow the instructions in your e-mail to verify your e-mail address</p>
            <button class="uk-button uk-button-primary uk-modal-close" type="submit">Ok</button>
        </div>
    </div>
</div>
<!-- End of modal -->
<!-- This is the Remove modal -->
<div id="modal-email-remove" uk-modal class="uk-flex-top modal-email-remove">
    <div class="uk-modal-dialog uk-margin-auto-vertical">
        <div class="uk-modal-body uk-text-center">
            <p> Are you sure you want to remove e-mail address <i><span class="remove-email">user@beamandgo.com</span></i>?</p>

            <form method="post" asp-page-handler="Remove" asp-antiforgery="true" data-ajax="true" data-ajax-method="post" data-ajax-success="removeEmailSuccess" data-ajax-failure="removeEmailFailed">
                <input type="hidden" asp-for="@Model.SelectedEmailSid" id="remove-selected" class="member-email-remove-input" />

                <button class="uk-button uk-button-primary" type="submit">Ok</button>

                @if (Model.IsXHR)
                {
                    <a class="uk-button uk-button-default" href="#bng-modal" uk-toggle>Cancel</a>
                }
                else
                {
                    <button class="uk-button uk-button-default uk-modal-close" type="button">Cancel</button>
                }

            </form>
        </div>
    </div>
</div>
<!-- End of modal -->
<script type="text/javascript">
    $('.member-email-remove').click(function () {
        $('.member-email-remove-input').val($(this).attr('SelectedEmailSid'));
        $('.remove-email').html($(this).attr('memberEmail'));
    });

    // Resend verification email.
    var modalResendVerification = '#modal-email-verification';
    resendVerificationSuccess = (email) => {
        let str = email;
        if (str.startsWith("<!DOCTYPE html>")) {
            UIkit.modal("#bng-modal").show();
            showErrorNotification('Sorry, we were unable to o generate a verification e-mail due to a system error. Please try again');
        } else {
            $('.modal-email-for-verified').text(email);
            UIkit.modal(modalResendVerification).show();
        }
    };
    resendVerificationFailed = (xhr) => {
        showErrorNotification(xhr.responseText);
    };

    // Change email notification
    changePrimarySuccess = (xhr) => {
        location.reload();
        showSuccessNotification(xhr);
    };
    changePrimaryFailed = (xhr) => {
        showErrorNotification(xhr.responseText);
    };

    // Remove Email
    removeEmailSuccess = (xhr) => {
        $("#modal-email-remove").remove();
        UIkit.modal("#bng-modal").hide();
        showSuccessNotification(xhr);
    };
    removeEmailFailed = (xhr) => {
        UIkit.modal("#bng-modal").show();
        showErrorNotification(xhr.responseText);
    };

    // Add Email
    addEmailSuccess = (xhr) => {
        location.reload();
        showSuccessNotification(xhr);
    };
    addEmailFailed = (xhr) => {
        showErrorNotification(xhr.responseText);
    };
</script>